#! /usr/bin/env python

class bgFairnessGenerator:
  def __init__(self, whichGenerator, outputfile, numAgents):
    self.numAgents = numAgents
    self.outputfile = outputfile
    self.whichGenerator = whichGenerator

  def defFstFairness(self):
    self.outputfile.write('''\
fairness = neg sndmsg[0] \/ rcvmsg[0]
fairness = neg sndack[0] \/ rcvack[0]\n\n''')

  def defSndFairness(self):
    clauses = []
    nums = self.numAgents / 2
    if self.numAgents % 2 == 0:      
      for i in range(nums):
        clauses.append( 'neg sndmsg[%d] \\/ rcvmsg[%d]' % (i, i) )
        clauses.append( 'neg sndack[%d] \\/ rcvack[%d]' % (i, i) )
    else:
      clauses.append( 'neg sndmsg[%d] \\/ rcvmsg[%d]' % (nums, nums))
      for i in range(nums):
        clauses.append( 'neg sndmsg[%d] \\/ rcvmsg[%d]' % (i, i) )
        clauses.append( 'neg sndack[%d] \\/ rcvack[%d]' % (i, i) )
    for clause in clauses:
      self.outputfile.write('fairness = ' + clause + '\n')

  def defFairness(self):
    if self.whichGenerator == 2 or self.whichGenerator == 4:
      self.defSndFairness()
    elif self.whichGenerator == 1:
      self.defFstFairness()
    else:
      pass
