#! /usr/bin/env python

# Builder Pattern


from bg_specification_generator import *
from bg_environment_generator import *
from bg_protocol_generator import *
from bg_fairness_generator import *

import sys
import os

if __name__ == '__main__':
  if (len(sys.argv) != 3):
    print 'Usage: python bg_generator.py <# of Agents> <index of Specification>'    
    print '<index of Specification> : 1, 2, 3, or 4'
    sys.exit()
  
  agents = sys.argv[1]
  numAgents = int(agents)
  
  numRuns = None 

 # print 'which kind of protocol do you like ? Enter a digit between 1 and 4'  
  whichGenerator = sys.argv[2]
  numGenerator = int(whichGenerator)
  while (numGenerator > 4) and (numGenerator < 1):
    print 'Please enter a digit between 1 and 4'
    whichGenerator = raw_input()
    numGenerator = int(whichGenerator)
 
 # get a directory to put all the generated mck scripts
  dirname = 'scripts'
  if(not os.path.isdir(dirname)):
    os.mkdir(dirname)
  os.chdir(dirname)
  
  filename = 'bg_'+ agents + '_' + whichGenerator 
 # get file to output  
  f = open(filename, 'w')

 # start building
  bgGenerator = bg_generator(numAgents, f)  
  bgGenerator.defDataType()
  bgGenerator.defInitCond()
  bgGenerator.defAgents()
  bgGenerator.defTransaction()

  
  fairnessGenerator = bgFairnessGenerator(numGenerator, f, numAgents)
  fairnessGenerator.defFairness()

  if numGenerator == 1:
    specGenerator = fstBGSpecGenerator(f, numAgents, numRuns )
  elif numGenerator == 2:
    specGenerator = sndBGSpecGenerator(f, numAgents, numRuns )
  elif numGenerator == 3:
    specGenerator = trdBGSpecGenerator(f, numAgents, numRuns )
  else:
    specGenerator = fthBGSpecGenerator(f, numAgents, numRuns )

  specGenerator.generateSpec()

  protocolGenerator = bgProtocolGenerator(f, numAgents)
  protocolGenerator.generateProtocol()
  
  f.close()
