#! /usr/bin/env python

class bgProtocolGenerator:
  def __init__(self, fileToWrite, numAgents):
    self.fileToWrite = fileToWrite
    if numAgents % 2 == 0:
      self.numMsg = numAgents / 2
      self.numAck = self.numMsg
    else:
      self.numMsg = numAgents/2 + 1
      self.numAck = numAgents/2

  def generateProtocol(self):
    self.fileToWrite.write('''\
    
protocol "sender" (sndmsg: observable Bool[%d], rcvack: observable Bool[%d], received: observable Bool)
begin
<< SendMsg >>;
do received /\ neg sndmsg[%d] -> << SendMsg >>
[] otherwise -> skip
od
end



-- Bob's protocol.
protocol "receiver" (sndack: observable Bool[%d], rcvmsg: observable Bool[%d], received : observable Bool)
begin
do received /\ neg sndack[%d] -> << SendAck >>
[] otherwise -> skip
od
end''' % (self.numMsg, self.numAck, self.numMsg-1, self.numAck, self.numMsg, self.numAck-1) )
