#! /usr/bin/env python

from dc_specification_generator import *
from dc_environment_generator import *
from dc_protocol_generator import *

import sys
import os

if __name__ == '__main__':
  if (len(sys.argv) != 3):
    print 'Usage: python dc_generator.py <# of Agents> <index of Specification>'
    print '<index of Specification> : 1, 2, 3, or 4'
    sys.exit()
  
  agents = sys.argv[1]
  numAgents = int(agents)
 
 # print 'which kind of protocol do you like ? Enter a digit between 1 and 4'  
  whichGenerator = sys.argv[2]
  numGenerator = int(whichGenerator)
  while (numGenerator > 4) and (numGenerator < 1):
    print 'Please enter a digit between 1 and 4'
    whichGenerator = raw_input()
    numGenerator = int(whichGenerator)
 
 # get a directory to put all the generated mck scripts
  dirname = 'scripts'
  if(not os.path.isdir(dirname)):
    os.mkdir(dirname)
  os.chdir(dirname) 
  filename = 'dc_' + agents + '_' + whichGenerator
 
 # get file to output
  f = open(filename, 'w')

 # start building
  dcGenerator = dc_generator(numAgents, f)  
  dcGenerator.defDataType()
  dcGenerator.defInitCond()
  dcGenerator.defAgents()
  dcGenerator.defTransaction()

  if numGenerator == 1:
    specGenerator = fstSpecGenerator(f, numAgents)
  elif numGenerator == 2:
    specGenerator = sndSpecGenerator(f, numAgents)
  elif numGenerator == 3:
    specGenerator = trdSpecGenerator(f, numAgents)
  else:
    specGenerator = fthSpecGenerator(f, numAgents)

  specGenerator.generateSpec()
  protocolGenerator = dc_protocol_generator(f)
  protocolGenerator.generateProtocol()
  
  f.close()
