#! usr/bin/env python

class dc_protocol_generator:
  def __init__(self, fileToWrite):  
    self.fileToWrite = fileToWrite
    
  def generateProtocol(self):
    self.fileToWrite.write('''\
    
protocol "dc_agent_protocol_original"
(
  paid : observable Bool,
  chan_left : observable Bool,
  chan_right : observable Bool,
  said : observable Bool[], -- the broadcast variables.
  stop : observable Bool
)


begin
  -- The environment tells us whether we paid or not.
  -- This agent decides the coin toss to the right.
  do stop -> skip
  [] otherwise -> 
      if chan_left xor chan_right xor paid -> << SayDifferent >>
      [] otherwise ->  << SaySame >>
      fi
  od
end''')
