#! /usr/bin/env python
# Builder Pattern

from pe_specification_generator import *
from pe_environment_generator import *
from pe_protocol_generator import *
import os
import sys

if __name__ == '__main__':
  if (len(sys.argv) != 3):
    print 'Usage: python dc_generator.py <# of length> <index of Specification>'
    print '<index of Specification> : 1, 2, 3, or 4'
    sys.exit()
  
  agents = sys.argv[1]
  numAgents = int(agents)
  
 # print 'which kind of protocol do you like ? Enter a digit between 1 and 4'  
  whichGenerator = sys.argv[2]
  numGenerator = int(whichGenerator)
  while (numGenerator > 4) and (numGenerator < 1):
    print 'Please enter a digit between 1 and 4'
    whichGenerator = raw_input()
    numGenerator = int(whichGenerator)
  
  filename = 'pe_' + agents + '_' + whichGenerator
 # get a directory to put all the generated mck scripts
  dirname = 'scripts'
  if(not os.path.isdir(dirname)):
    os.mkdir(dirname)
  os.chdir(dirname)
 
 # get file to write
  f = open(filename, 'w')

  peGenerator = pe_generator(numAgents, f)  
  peGenerator.defDataType()
  peGenerator.defInitCond()
  peGenerator.defAgents()
  peGenerator.defTransaction()

  if numGenerator == 1:
    specGenerator = fstPESpecGenerator(f, numAgents)
  elif numGenerator == 2:
    specGenerator = sndPESpecGenerator(f, numAgents)
  elif numGenerator == 3:
    specGenerator = trdPESpecGenerator(f, numAgents)
  else:
    specGenerator = fthPESpecGenerator(f, numAgents)

  specGenerator.generateSpec()

  protocolGenerator = peProtocolGenerator(f)
  protocolGenerator.generateProtocol()
  
  f.close()
