#! /usr/bin/env python

# Abstract Factory Pattern
# 1..4

class peSpecification:
  def __init__(self, fileToWrite, numAgents):
    self.numAgents = numAgents    
    self.fileToWrite = fileToWrite

  def generateSpec(self):
    pass

  def generateAtomElem(self, atomStr): 
    elems = []   
    for i in range(self.numAgents):
      elems.append(('(' + atomStr + '==%d' + ')') % i)
    return elems 
                       
class fstPESpecGenerator(peSpecification):
  def __init__(self, fileToWrite, numAgents):
    peSpecification.__init__(self, fileToWrite, numAgents)
    
  def generateSpec(self):    
    self.fileToWrite.write( '\nspec_obs = AG ((found /\\ direction == 0) => ((Knows Alice evaderPos==pursuerPos)\\/(Knows Alice evaderPos == pursuerPos - 1))) \n' )

class sndPESpecGenerator(peSpecification):
  def __init__(self, fileToWrite, numAgents):
    peSpecification.__init__(self, fileToWrite, numAgents)
    
  def generateSpec(self):
    knows = self.generateAtomElem('Knows Alice evaderPos')
    self.fileToWrite.write( '\nspec_obs = AG (found => ' )     
    knowformula = ''
    for i in range(0, (self.numAgents-1)):
      knowformula += knows[i] + ' \\/ '
    knowformula += knows[self.numAgents-1]
    self.fileToWrite.write( knowformula + ' )\n' )
  
class trdPESpecGenerator(peSpecification):
  def __init__(self, fileToWrite, numAgents):
    peSpecification.__init__(self, fileToWrite, numAgents)

  def generateSpec(self):
    self.fileToWrite.write( '\nspec_obs = AF ((direction == 0) /\\ ((Knows Alice evaderPos==pursuerPos) \\/ (Knows Alice evaderPos==pursuerPos-1)))\n')
    
class fthPESpecGenerator(peSpecification):
  def __init__(self, fileToWrite, numAgents, runs):
    peSpecification.__init__(self, fileToWrite, numAgents)
   
  def generateSpec(self):
    self.fileToWrite.write( '\nspec_obs = AG (found => Knows Alice (evaderPos==pursuerPos\/evaderPos==pursuerPos-1\/evaderPos==pursuerPos+1))\n' )
    

